package com.altinity.opsview.odw.elements;

/**
 * Copyright (C) 2008 Opsera Limited. All rights reserved
 *
 * This file is part of Opsview
 * 
 * Opsview is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * Opsview is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Opsview; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301  USA
 * 
 */

import java.io.File;
import java.io.IOException;

import org.dom4j.Element;
import org.jfree.chart.ChartUtilities;
import org.jfree.chart.JFreeChart;

import com.altinity.opsview.odw.bc.ODWReportLogger;
import com.altinity.opsview.odw.dao.ODWReportConfigDAO;
import com.altinity.opsview.odw.dao.ODWReportDAO;
import com.altinity.opsview.odw.exception.ReportException;
import com.altinity.opsview.odw.reports.ReportCriteria;

public abstract class AbstractReportElement {

	protected ReportCriteria rc = null;
	protected ODWReportDAO dao = null;
	protected ODWReportConfigDAO configDao = null;
	protected ODWReportLogger log = null;
	
	/**
	 * 
	 */
	protected AbstractReportElement(ReportCriteria rc, ODWReportDAO dao, ODWReportConfigDAO configDao, ODWReportLogger log) {
		
		this.rc = rc;
		this.dao = dao;
		this.configDao = configDao;
		this.log = log;
	}
	
	/**
	 * 
	 * @param bimage
	 * @param fileName
	 */
	protected String saveImageToTempDir(JFreeChart chart, String name) {
	
		String fileName =  name + "." + rc.getFileFormat();
		
		String filePath = rc.getChartsRoot() + "/" + fileName;

		File f = new File(filePath);
		
		// Save the chart
		try {

			ChartUtilities.saveChartAsJPEG(f, 1, chart,1000,333);
			
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return fileName;
	}
	
	/**
	 * 
	 */
	public abstract void runQuery() throws ReportException;
	
	/**
	 * 
	 */
	public abstract Element addElement(Element elements);
}
